#!/usr/bin/python2.4
# -*- coding: utf-8 -*-

import re
from cStringIO import StringIO

import pycurl
import urllib

from moio.plugins.Sender import Sender
from moio.ConnectionManager import ConnectionManager
from moio.errors.SiteCustomError import SiteCustomError
from moio.errors.SiteConnectionError import SiteConnectionError
from moio.errors.SiteAuthError import SiteAuthError
from moio.errors.SenderError import SenderError

class Callwave(Sender):
    """Permette di spedire SMS dal sito callwave.com"""
    
    maxLength = 125
    """Lunghezza massima del messaggio singolo inviabile da questo sito."""
    
    requiresRegistration = True
    """Questo plugin richiede nome utente e password?"""
    
    def isAvailable(self):
        """Ritorna true se questo plugin è utilizzabile."""
        return True
       
    def sendOne(self, number, text, username = None, password = None):
        """Spedisce un SMS con soli caratteri ASCII e di lunghezza massima maxLength
        con le credenziali specificate, supponendo Internet raggiungibile.
        """
        try:
            c = self.connectionManager.getCurl()
            c.setopt(pycurl.WRITEFUNCTION, self.doNothing)
            c.setopt(pycurl.POST, False)

            #Faccio il login
            saver = StringIO()
            c.setopt(pycurl.WRITEFUNCTION, saver.write)
            c.setopt(pycurl.POST, True)
            username=self.codingManager.xmlEncode(username)
            password=self.codingManager.xmlEncode(password)
            if username[0] != "+":
                username = "+39 "+username
            postFields = """<?xml version="1.0" encoding="ISO-8859-1"?><request><type>AUTH</type><src>SX</src><ver>3.6</ver><os>MacIntel</os><phone>%s</phone><pin>%s</pin></request>""" % (username, password)
            postFields = str(postFields)
            
            c.setopt(pycurl.POSTFIELDS, postFields)
            c.setopt(pycurl.URL, "http://wx0.callwave.com/v2w")
            c.perform()
            
            if ((re.search("Authentication succeeded", saver.getvalue()) is None)):
                raise SiteAuthError(self.__class__.__name__)
            
            account = re.search('<account>([0-9]+)</account>',saver.getvalue()).group(1)
            uString = re.search('<uString>([0-9a-f]+)</uString>',saver.getvalue()).group(1)
            
            text=self.codingManager.xmlEncode(text)
            if number[0] != "+":
                number = "+39"+number
            postFields = """<?xml version="1.0" encoding="ISO-8859-1"?><request><type>SSMS</type><src>SX</src><ver>3.6</ver><os>MacIntel</os><account>%s</account><uString>%s</uString><sendToPhoneNumber>%s</sendToPhoneNumber><sendToCarrierID>-1</sendToCarrierID><sendFromPreference>0</sendFromPreference><message>%s</message></request>""" % (account, uString, number, text)
            postFields = str(postFields)
            c.setopt(pycurl.POSTFIELDS, postFields)
            c.perform()
            
            if (re.search("Exceeded daily limit", saver.getvalue(), re.I) is not None):
                raise SiteCustomError(self.__class__.__name__,
                    u"Sono esauriti gli SMS gratuiti di oggi.")

            if (re.search("Message not sent", saver.getvalue(), re.I) is not None):
                raise SiteCustomError(self.__class__.__name__,
                    u"Hai esaurito i tuoi crediti per gli SMS con il sito Callwave.")

            if (re.search("Message sent", saver.getvalue(), re.I) is None):
                raise SenderError(self.__class__.__name__)

        except pycurl.error, e:
            errno, msg = e
            raise SiteConnectionError(self.__class__.__name__, self.codingManager.iso88591ToUnicode(msg))
