#!/usr/bin/python2.4
# -*- coding: utf-8 -*-

import re
from cStringIO import StringIO

import pycurl

from moio.plugins.Sender import Sender
from moio.ConnectionManager import ConnectionManager
from moio.errors.SiteCustomError import SiteCustomError
from moio.errors.SiteConnectionError import SiteConnectionError
from moio.errors.SiteAuthError import SiteAuthError
from moio.errors.SenderError import SenderError

class Kly(Sender):
    """Permette di spedire SMS dal sito kly.it"""
    
    requiresRegistration = True
    """Questo plugin richiede nome utente e password?"""
    
    def isAvailable(self):
        """Ritorna true se questo plugin è utilizzabile."""
        return True

    def sendOne(self, number, text, username = None, password = None):
        """Spedisce un SMS con soli caratteri ASCII e di lunghezza massima maxLength
        con le credenziali specificate, supponendo Internet raggiungibile.
        """
        try:
            c = self.connectionManager.getCurl()
            c.setopt(pycurl.CONNECTTIMEOUT, 0)
            c.setopt(pycurl.TIMEOUT, 300)
            c.setopt(pycurl.WRITEFUNCTION, self.doNothing)
            c.setopt(pycurl.FOLLOWLOCATION, True)
            
            saver = StringIO()
            c.setopt(pycurl.WRITEFUNCTION, saver.write)
            c.setopt(pycurl.POST, True)
            postFields = {}
            postFields["cookieneverexp"] = "cookieneverexp"
            postFields["user"] = username
            postFields["passwrd"] = password
            c.setopt(pycurl.POSTFIELDS,
                self.codingManager.urlEncode(postFields))
    
            #Faccio il login
            c.setopt(pycurl.URL,
                "http://www.kly.it/forum/index.php?action=login2")
            c.perform()
            
            if (re.search("Username non esiste", saver.getvalue()) != None or\
                re.search("Password non corretta", saver.getvalue()) != None):
                raise SiteAuthError(self.__class__.__name__)
            
            #invio
            saver = StringIO()
            c.setopt(pycurl.WRITEFUNCTION, saver.write)
            c.setopt(pycurl.POST, True)
            postFields = {}
            postFields["TextMessage"] = text
            postFields["prefisso"] = number[0:3]
            postFields["PhoneNumber"] = number[3:]
            c.setopt(pycurl.POSTFIELDS,
                self.codingManager.urlEncode(postFields))
    
            c.setopt(pycurl.URL,
                "http://www.kly.it/index.php?pid=sms&azione=nuovo&step=3")
            c.perform()
            
            if (re.search(
                "Hai esaurito gli sms gratuiti a tua disposizione per oggi",
                saver.getvalue()) != None):
                raise SiteCustomError(self.__class__.__name__,
                    u"Sono esauriti gli SMS gratuiti di oggi.")
            if (re.search("SMS inviato", saver.getvalue()) == None):
                raise SenderError(self.__class__.__name__)

        except pycurl.error, e:
            errno, msg = e
            raise SiteConnectionError(self.__class__.__name__, self.codingManager.iso88591ToUnicode(msg))
