#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys
import traceback

from moio.plugins.Sender import Sender
from moio.PreferenceManager import PreferenceManager
from moio.plugins.UI import UI

class GraphicalUI(UI):
    """Interfaccia grafica in wxpython."""

    MainFrame = None
    
    def isAvailable(self):
        """Ritorna true se quest'interfaccia è utilizzabile."""
        #non ci devono essere parametri se -ui non è specificato
        result = (len(sys.argv) == 1) or ("-gui" in sys.argv)
        try:
            #deve essere installata correttamente wxpython
            import wx
            from moio.plugins.uis.MainFrame import MainFrame
        except ImportError, e:
            result = False
            print e
        return result

    def getPriority(self):
        """Ritorna un codice di priorità. In caso più interfacce siano
        utilizzabili, viene scelta quella a maggiore priorità."""
        return 3
    
    def run(self):
        """Avvia questa interfaccia."""
        import wx
        from moio.plugins.uis.MainFrame import MainFrame
        WxUIApp = wx.PySimpleApp(0)
        wx.InitAllImageHandlers()
        self.MainFrame = MainFrame(None, -1, "")
        WxUIApp.SetTopWindow(self.MainFrame)
        self.MainFrame.Show()
        WxUIApp.MainLoop()

    def showFatalException(self, message):
        """Questo metodo viene richiamato nel caso in cui venga catturata
        un'eccezione non gestita nel programma principale."""
        import wx
        wx.MessageBox(message, "Errore", wx.OK)
    
         